<template>
  <svn-pro-card
    :link="false"
    variant="outlined"
    :disabled="disabled"
    class="bg-surface !rounded-[16px] !border-[0.5px] border-opacity-100"
    :class="state === 'error' ? '!border-[#BA1A1A]' : '!border-[#767680]'"
    :id="id"
  >
    <div
      class="w-full flex flex-col gap-6"
      :class="size === 'compact' ? 'p-6' : 'p-8'"
    >
      <div class="flex flex-col gap-2">
        <div
          v-if="hasTitle"
          class="w-full flex flex-col gap-1.5"
        >
          <svn-pro-text
            v-if="size === 'compact' && questionType !== InterviewAppQuestionTypes?.paragraph"
            medium
            subtitle-large
          >
            {{ title }}
          </svn-pro-text>

          <svn-pro-title
            v-else-if="size !== 'compact' && questionType !== InterviewAppQuestionTypes?.paragraph"
            h5
            medium
          >
            {{ title }}
          </svn-pro-title>

          <div
            v-else-if="questionType === InterviewAppQuestionTypes?.paragraph"
            class="text-onSurfaceVariant font-weight-regular"
            :class="size === 'compact' ? 'text-body-2' : 'text-body-1'"
            v-html="title"
          />

          <svn-pro-divider v-if="hasDivider" color="[#767680]" class="w-full" />
        </div>

        <div
          v-if="hasDescription"
          class="text-onSurfaceVariant font-weight-regular"
          :class="size === 'compact' ? 'text-body-2' : 'text-body-1'"
          v-html="description"
        />
      </div>

      <slot v-if="hasVariableContent" name="variable-content" />

      <svn-pro-button
        v-if="hasComment"
        :text="`Comments`"
        variant="text"
        class="w-fit"
        @click="emit('on-comment-clicked')"
      />

      <div
        v-if="hasEditableArea"
        class="w-full flex flex-col gap-4"
      >
        <v-rating
          v-if="type === FormBlockTypes.icon_buttons"
          :length="ratingLength"
          :model-value="indicatorCurrentValue"
          empty-icon="custom:mingcute:star-line"
          full-icon="custom:mingcute:star-fill"
          color="onSurface"
          size="small"
          active-color="primary"
          @update:model-value="updateAnswer"
        />

        <svn-pro-select
          v-if="type === FormBlockTypes.autocomplete"
          v-model="indicatorCurrentValue"
          item-value="item"
          item-title="item"
          :label="ratingSelectLabel"
          class="w-full max-w-[320px]"
          :items="MCQOptions"
        />

        <v-radio-group
          v-if="type === FormBlockTypes.radio_buttons"
          v-model="indicatorCurrentValue"
          hide-details
        >
          <div
            v-for="item of MCQOptions"
            class="flex items-center w-fit"
          >
            <svn-pro-radio-button
              :value="item"
              :id="`${id}--${item}`"
              color="primary"
              @click="updateAnswer(item)"
            />

            <label :for="`${id}--${item}`" class="cursor-pointer">
              <svn-pro-text :body-large="size !== 'compact'" :body-medium="size === 'compact'">
                {{ item }}
              </svn-pro-text>
            </label>
          </div>
        </v-radio-group>

        <svn-pro-text-area
          v-if="type === FormBlockTypes.text_area"
          v-model="indicatorCurrentValue"
          variant="outlined"
          :rows="6"
          :max-rows="6"
          label="Answer"
          @update:model-value="updateAnswer"
        />

        <svn-pro-text-area
          v-if="hasCommentArea"
          v-model="comment"
          variant="outlined"
          :rows="6"
          :max-rows="6"
          label="Commet"
          @update:model-value="updateComments"
        />
      </div>
    </div>
  </svn-pro-card>
</template>

<script setup>
import { ref, watch, onMounted } from 'vue';
import SvnProCard from '../card/SvnProCard.vue';
import SvnProText from '../styles/SvnProText.vue';
import SvnProTitle from '../styles/SvnProTitle.vue';
import SvnProSelect from '../input/SvnProSelect.vue';
import SvnProButton from '../button/SvnProButton.vue';
import { FormBlockTypes, InterviewAppQuestionTypes } from '../../constants/types';
import SvnProDivider from '../divider/SvnProDivider.vue';
import SvnProTextArea from '../input/SvnProTextArea.vue';
import SvnProRadioButton from '../input/SvnProRadioButton.vue';

const props = defineProps({
  hasTitle: { type: Boolean, default: true },
  title: { String, default: "" },
  size: { String, default: "compact" },
  hasDivider: { type: Boolean, default: false },
  description: { String, default: "" },
  hasDescription: { type: Boolean, default: true },
  state: { String, default: "default" },
  comments: { String, default: "" },
  hasComment: { type: Boolean, default: false },
  hasCommentArea: { type: Boolean, default: true },
  disabled: { type: Boolean, default: false },
  inputLabel: { String, default: "Answer" },
  ratingLength: { type: undefined, default: "5" },
  selectedValue: { type: undefined, default: "4" },
  MCQOptions: { type: Array, default: () => [] },
  ratingSelectLabel: { String, default: "Choose option" },
  hasEditableArea: { type: Boolean, default: true },
  hasVariableContent: { type: Boolean, default: false },
  type: { type: String, default: FormBlockTypes?.text_area },
  questionType: { type: String, default: "" },
  id: { type: String, default: "" },
});

const emit = defineEmits([
  'update-answer',
  'update-comments',
  'on-comment-clicked',
]);

onMounted(() => {
  comment.value = props?.comments

  if (props?.type === FormBlockTypes.icon_buttons || props?.type === FormBlockTypes.radio_buttons || props?.type === FormBlockTypes?.text_area) {
    indicatorCurrentValue.value = props.selectedValue
  }
});

const comment = ref(null);
const indicatorCurrentValue = ref(null);

const updateAnswer = (value) => {
  if (props?.type === FormBlockTypes.icon_buttons || props?.type === FormBlockTypes.radio_buttons) {
    indicatorCurrentValue.value = value
  }
  emit('update-answer', value)
}

const updateComments = (value) => {
  emit('update-comments', value)
}

watch(props, (newValue, oldValue) => {
  if (newValue?.comments) {
    comment.value = newValue?.comments
  }

  if (newValue?.selectedValue) {
    indicatorCurrentValue.value = newValue.selectedValue
  }
})
</script>

<style scoped>
/* Because the 'class' doesn't work on v-radio-group */
:deep(.v-selection-control-group) {
  gap: 12px;
}
</style>